
/*
MathGraph32 Java. Software for creating and animating dynamic mathematics figures
    Copyright (C) 2009  Yves Biton (France) http://mathgraph32.org 

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

package actions;

import java.awt.event.ActionEvent;

import objets.CListeObjets;

import types.NatureObjet;
import dialogs.ExporterCodeTikzDlg;
import mathgraph32.MtgFrame;
import mathgraph32.MtgInternalFrame;

@SuppressWarnings("serial")
public class ActionFichierExporterTikz extends MtgAction {
	public ActionFichierExporterTikz(MtgFrame frameInit) {
		super(frameInit, null, getString("menuExportTikz"), getString("menuExportTikz"), null, null, false);
	}
  public int idMenu() {
    return 57637;
  }
	@Override
	public void actionPerformed(ActionEvent e) {
		MtgInternalFrame cadre = frame.cadreActif();
		CListeObjets liste = cadre.listePr;
		if (cadre != null) {
			if (((cadre.document.imageFond != null) || (liste.nombreObjetsParNature(NatureObjet.NImage) != 0)) && cadre.document.path.isEmpty()) {
				frame.dialogueAvertissement(getString("messageFichierNonEnregistre"));
				return;
			}
			ExporterCodeTikzDlg dlg = new ExporterCodeTikzDlg(frame);
			dlg.setLocationRelativeTo(frame);
			dlg.setVisible(true);
		}
	}

}
