/*
MathGraph32 Java. Software for creating and animating dynamic mathematics figures
    Copyright (C) 2009  Yves Biton (France) http://mathgraph32.org 

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
package actions;

import java.awt.event.ActionEvent;
import mathgraph32.MtgFrame;
import mathgraph32.MtgInternalFrame;

@SuppressWarnings("serial")
public class ActionModeTraceActivation extends MtgAction {

	public ActionModeTraceActivation(MtgFrame frameInit) {
		super(frameInit, null, getString("menuModeTrace"), getString("tipModeTrace"), iconeAssociee(), null, true);
	}
	
	@Override
	public void actionPerformed(ActionEvent e) {
		MtgInternalFrame cadre = frame.cadreActif();
		cadre.activeModeTrace(!cadre.document.modeTraceActive);
		cadre.initialisetbuffer();
		if (!cadre.document.modeTraceActive) cadre.repaintFigureSansCalcul();
	}
	
	// Ajout version 4.3 pour que l'outil soit slectionnable ou non
	/* Supprim version 4.4.1 car l'outil ne peut pas tre choisi pusique pas de menu Options dans le choix des outils	
  @Override
  public int idMenu() {
    return 32019;
  }
  */
	
  public static String iconeAssociee() {
    return "images/Traces24";
  }
	
}
