/*
MathGraph32 Java. Software for creating and animating dynamic mathematics figures
    Copyright (C) 2009  Yves Biton (France) http://mathgraph32.org 

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

package dialogs;

import java.awt.Dimension;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;
import objets.CCalcul;
import objets.CElementBase;
import objets.CFonc;
import objets.CListeObjets;
import objets.CVariableBornee;
import types.NatureCalcul;
import types.NatureObjet;
import mathgraph32.MtgFrame;
import mathgraph32.MtgInternalFrame;

@SuppressWarnings("serial")
public class AffichageObjetsNumeriquesDlg extends MtgDlg implements MouseListener{
  // private ListeObjetsNumeriquesEtReperes listeVal; Modifi version 4.9.2
  private ListeObjetsNumeriquesPourReclassement listeVal;
  private MtgButton btnFermer,btnReclasserDebut,btnReclasserFin,btnSupprimer,btnModifier,
  	btnCreerCalcul, btnCreerFonction;
  private MtgTextArea info;
  private JScrollPane scrollPaneListe, scrollPaneInfo;

  public AffichageObjetsNumeriquesDlg(MtgFrame frameInit) {
    super(getString("affichageValeursNumeriquesDlg1"), true, frameInit);
    initComponents();
    getRootPane().setDefaultButton(btnFermer);
  }
  
  private void initComponents() {
  	btnReclasserDebut = new MtgButton(frame, getString("btnReclasserDebut"));
  	btnReclasserDebut.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        btnReclasserDebutActionPerformed();
      }
    });
  	btnReclasserFin = new MtgButton(frame, getString("btnReclasserFin"));
  	btnReclasserFin.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        btnReclasserFinActionPerformed();
      }
    });
  	btnCreerCalcul = new MtgButton(frame, getString("chaineOutil20"));
  	btnCreerCalcul.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        btnCreerCalculActionPerformed();
      }
    });
  	btnCreerCalcul.setPreferredSize(btnReclasserDebut.getPreferredSize());
  	btnCreerFonction = new MtgButton(frame, getString("chaineOutil49"));
  	btnCreerFonction.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        btnCreerFonctionActionPerformed();
      }
    });
  	btnCreerFonction.setPreferredSize(btnReclasserDebut.getPreferredSize());
    btnFermer = new MtgButton(frame, getString("btnFermer"));
  	btnFermer.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        dispose();
        frame.activeOutilCapture();
      }
    });
  	btnFermer.setPreferredSize(btnReclasserDebut.getPreferredSize());
  	btnSupprimer = new MtgButton(frame, getString("btnSupprimer"));
  	btnSupprimer.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        btnSupprimerActionPerformed();
      }
    });
  	btnSupprimer.setPreferredSize(btnReclasserDebut.getPreferredSize());
  	btnModifier = new MtgButton(frame, getString("btnModifier"));
  	btnModifier.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        btnModifierActionPerformed();
      }
    });
  	btnModifier.setPreferredSize(btnReclasserDebut.getPreferredSize());
  	// Dernier paramtre  true pour permettre tous les objets
    listeVal = new ListeObjetsNumeriquesPourReclassement(frame, frame.cadreActif().listePr, frame.cadreActif().listePr.size() - 1, false, true);
    listeVal.addListSelectionListener(new ListSelectionListener() {
      public void valueChanged(ListSelectionEvent evt) {
      	listeValSelectionChanged();
      }
    });
    // Ajout version 4.9.9 pour grer la touche Suppression
    listeVal.addKeyListener(new KeyListener() {
			
			public void keyTyped(KeyEvent e) {
			}
			
			public void keyReleased(KeyEvent e) {
			}
			
			public void keyPressed(KeyEvent e) {
				if ((e.getKeyCode() == KeyEvent.VK_DELETE) && (btnSupprimer.isVisible()))
					btnSupprimerActionPerformed();
			}
		});
    listeVal.addMouseListener(this);
    scrollPaneListe = new JScrollPane(listeVal, JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED, JScrollPane.HORIZONTAL_SCROLLBAR_AS_NEEDED);
    info = new MtgTextArea(frame);
    scrollPaneInfo = new JScrollPane(info, JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED, JScrollPane.HORIZONTAL_SCROLLBAR_AS_NEEDED);
    info.setEditable(false);
    // info.setColumns(20); // Modifi version 4.9.4
    info.setColumns(30);
    info.setEditable(false);
    info.setLineWrap(false);
    // info.setRows(4); Modifi version 4.9.4
    info.setRows(5);
    // Ajout version 5.0 pour ne pas utiliser les polices par dfaut trop grandes sous Windows
    // Modification version 5.0 pour tenir compte des crans haute rsolution
    double k = MtgFrame.coefMultForDlgBoxIcons;
    //
    // scrollPaneInfo.setPreferredSize(new Dimension(350, 100)); Modifi version 4.9.4
    scrollPaneInfo.setPreferredSize(new Dimension((int)(k*400), (int)(k*130)));
    JPanel pane = new JPanel();
    pane.setLayout(new GridBagLayout());
    GridBagConstraints constraints = new GridBagConstraints();
    constraints.insets.top = 5;
    constraints.insets.bottom = 5;
    constraints.insets.left = 5;
    constraints.insets.right = 5;
    
    setConstraints(constraints, 0, 0, 1, 1, 80, 50, GridBagConstraints.HORIZONTAL, GridBagConstraints.WEST);
    pane.add(scrollPaneListe, constraints);
    setConstraints(constraints, 0, 1, 1, 1, 0, 50, GridBagConstraints.HORIZONTAL, GridBagConstraints.WEST);
    pane.add(scrollPaneInfo, constraints);
    
    JPanel paneRight = new JPanel(); // Pour mettre les deux boutons en haut et  droite
    paneRight.setLayout(new GridBagLayout());
    setConstraints(constraints, 0, 0, 1, 1, 100, 10, GridBagConstraints.HORIZONTAL, GridBagConstraints.NORTHEAST);
    paneRight.add(btnFermer, constraints);
    setConstraints(constraints, 0, 1, 1, 1, 100, 10, GridBagConstraints.HORIZONTAL, GridBagConstraints.NORTHEAST);
    paneRight.add(btnReclasserDebut, constraints);
    setConstraints(constraints, 0, 2, 1, 1, 100, 10, GridBagConstraints.HORIZONTAL, GridBagConstraints.NORTHEAST);
    paneRight.add(btnReclasserFin, constraints);
    setConstraints(constraints, 0, 3, 1, 1, 100, 10, GridBagConstraints.HORIZONTAL, GridBagConstraints.NORTHEAST);
    paneRight.add(btnSupprimer, constraints);
    setConstraints(constraints, 0, 4, 1, 1, 100, 10, GridBagConstraints.HORIZONTAL, GridBagConstraints.NORTHEAST);
    paneRight.add(btnModifier, constraints);
    setConstraints(constraints, 0, 5, 1, 1, 100, 10, GridBagConstraints.HORIZONTAL, GridBagConstraints.NORTHEAST);
    paneRight.add(btnCreerCalcul, constraints);
    setConstraints(constraints, 0, 6, 1, 1, 100, 10, GridBagConstraints.HORIZONTAL, GridBagConstraints.NORTHEAST);
    paneRight.add(btnCreerFonction, constraints);
    
    setConstraints(constraints, 1, 0, 1, 2, 20, 0, GridBagConstraints.NONE, GridBagConstraints.NORTHEAST);
    pane.add(paneRight, constraints);
    
    setContentPane(pane);
    if (listeVal.pointeurs.size() > 1) listeVal.setSelectedIndex(1);
    listeValSelectionChanged();      
    pack();
      	
  }
  
  private void listeValSelectionChanged() {
  	int i = listeVal.getSelectedIndex();
  	if (i != -1) {
  		CElementBase elb = listeVal.pointeurs.get(i);
  		// Modifi version 4.9.4
  		String ch =  elb.infoPourHistorique();
  	  ch += "\n" + getString("Nhtml" ) + " "  + elb.index; // Ajout version 4.9.4 pour communication html
  	  info.setText(ch);
  		info.setCaretPosition(0);
  		pack();
  		boolean b= elb.estDeNatureCalcul(NatureCalcul.NToutObjetNumeriquesSaufConst);
  		btnReclasserDebut.setVisible(b);
  		btnReclasserFin.setVisible(b);
  		btnSupprimer.setVisible(b);
  		// Modification version 4.9.7 pour permettre de modifier un repre
  		// if (elb.estDeNatureCalcul(NatureCalcul.NCalculOuVariableOuFonctionReelOuComplexe)) {
  		if (elb.estDeNatureCalcul(NatureCalcul.NCalculOuVariableOuFonctionReelOuComplexe | NatureCalcul.NRepere)) 	
  			b = elb.modifiableParMenu();
  		else b = false;
  		btnModifier.setVisible(b);
  		
  	}
  }
  private void btnReclasserDebutActionPerformed() {
  	MtgInternalFrame cadre = frame.cadreActif();
  	CListeObjets liste = cadre.listePr;
  	CElementBase val =listeVal.valeurSelectionnee();
  	if (liste.reclasseVersDebutAvecDependants(val)) {
  		dialogueAvertissement(getString("reclassementDebutObjetGraphique2"));
			cadre.listePr.metAJourParNatureObjet(NatureObjet.NCommentaireOuLatex); // Ajout version 4.6 pour que les dpendances de commentaires et laTeX dynamiques soient remis  jour
			cadre.gestionnaire.enregistreFigureEnCours(getString("chaineOutil98"));
			cadre.repaintFigureAvecCalcul();
			listeVal.metAJourListe();
	    cadre.videListesPourConstructions();  // On remet  jour une construction ventuellement commence
  	}
  	else dialogueAvertissement(getString("reclassementDebutObjetGraphique3"));  		
  }
  private void btnCreerCalculActionPerformed() {
  	MtgInternalFrame cadre = frame.cadreActif();
  	CListeObjets liste = cadre.listePr;
    frame.indication("");
    CCalcul cal = new CCalcul(liste, null, false);    
    CalculReelDlg dlg = new CalculReelDlg(frame, cal, false);
		dlg.setLocationRelativeTo(frame);
    dlg.setVisible(true);
    if (dlg.retourOK()) {
      if (frame.ajouteElementAvecVerification(cal))
        cadre.gestionnaire.enregistreFigureEnCours(getString("chaineOutil20"));
      	listeVal.metAJourIndiceMaxi(liste.size()-1);
      	listeVal.metAJourListe();
    }
  }
  private void btnCreerFonctionActionPerformed() {
  	MtgInternalFrame cadre = frame.cadreActif();
  	CListeObjets liste = cadre.listePr;
    frame.indication("");
    CFonc fon = new CFonc(liste, null, false);    
    FonctionReelleDlg dlg = new FonctionReelleDlg(frame, fon, false);
		dlg.setLocationRelativeTo(frame);
    dlg.setVisible(true);
    if (dlg.retourOK()) {
      if (frame.ajouteElementAvecVerification(fon))
      	if (dlg.courbeDemandee) {
    			cadre.ajouteCourbeSurR(dlg.listeReperes.repereChoisi(), fon,
    					liste.genereNomPourPointOuDroiteAvecChiffre('x'), liste.genereNomPourCalcul("x", true),
    					liste.genereNomPourCalcul("y", true), dlg.nombrePoints, true, true, true);
      	}
      cadre.gestionnaire.enregistreFigureEnCours(getString("chaineOutil49"));    	
    	listeVal.metAJourIndiceMaxi(liste.size()-1);
    	listeVal.metAJourListe();
    	cadre.redessineSansCalcul();
  		// Si on n'appelle pas paintImmediatly seule la rgion situe sous le menu est mise  jour
  		cadre.paneFigure.paintImmediately(0, 0, cadre.dimf.longueurAbscisses, cadre.dimf.longueurOrdonnees);
    }
  }

  private void btnReclasserFinActionPerformed() {
  	MtgInternalFrame cadre = frame.cadreActif();
  	CListeObjets liste = cadre.listePr;
  	CElementBase val =listeVal.valeurSelectionnee();
  	if (liste.reclasseVersFinAvecDependants(val)) {
  		dialogueAvertissement(getString("reclassementFinObjetGraphique2"));
			cadre.listePr.metAJourParNatureObjet(NatureObjet.NCommentaireOuLatex); // Ajout version 4.6 pour que les dpendances de commentaires et laTeX dynamiques soient remis  jour
			cadre.gestionnaire.enregistreFigureEnCours(getString("chaineOutil98"));
			cadre.repaintFigureAvecCalcul();
			listeVal.metAJourListe();
	    cadre.videListesPourConstructions();  // On remet  jour une construction ventuellement commence
	 }
	 else dialogueAvertissement(getString("reclassementFinObjetGraphique3"));  		
  }
  
  private void btnSupprimerActionPerformed() {
  	CElementBase elb =listeVal.valeurSelectionnee();
  	MtgInternalFrame cadre = frame.cadreActif();
  	CListeObjets liste = cadre.listePr;
  	int ind = liste.indexOf(elb);
  	boolean suppression = false;
  	if (liste.nombreDependants(elb) >= 2) {
      if (frame.dialogueConfirmation_YES_NO(getString("ch37"))) {
        frame.retireDependants(elb);
        cadre.gestionnaire.enregistreFigureEnCours(getString("chaineOutil116"));
        suppression = true;
      }      
    }
    else {
      frame.retireDependants(elb);
      cadre.gestionnaire.enregistreFigureEnCours(getString("chaineOutil116"));
      cadre.effacegbuffer();
      cadre.repaintFigureSansCalcul();
      suppression = true;
    }
  	if (suppression) {
      // Si on a retir la longueur unit de la figure, elle doit en tre informe
      if (elb == liste.pointeurLongueurUnite) liste.pointeurLongueurUnite = null;
      if (elb.getNatureCalcul() == NatureCalcul.NVariable) {
  			if (((CVariableBornee)elb).dialogueAssocie) {
	  			// cadre.supprimeDialogueAffichageVariables();
	  			// cadre.creeDialogueAffichageVariables();
  				cadre.creePaneAffichageVariables();
  			}
  		}
  			
  		
      cadre.videListesPourConstructions();  // On remet  jour une construction ventuellement commence
      int nb = liste.nombreObjetsParNatureCalculNonIntermediaires(NatureCalcul.NToutObjetNumeriquesSaufConst);
      if (nb == 0) {
      	cadre.effacegbuffer();
        cadre.repaintFigureSansCalcul();
      	dispose();
      	return;
      }
      listeVal.metAJourIndiceMaxi(liste.size() - 1);
      listeVal.metAJourListe();
      if (ind >= nb) ind --;
      cadre.effacegbuffer();
      cadre.repaintFigureSansCalcul();
      listeVal.setSelectedIndex(ind);
      listeValSelectionChanged();
  	}
  }
  public void btnModifierActionPerformed() {
  	MtgInternalFrame cadre = frame.cadreActif();
  	int i = listeVal.getSelectedIndex();
  	if (i != -1) {
  		// Modifi version 4.9.7 pour autoriser la modification d'un repre
  		// CValeurDynamique val = (CValeurDynamique) listeVal.pointeurs.get(i);
  		CElementBase val = (CElementBase) listeVal.pointeurs.get(i);
      if (val.modifiableParMenu()) {
      	MtgDlg dlg = val.dialogueModification(frame);
      	dlg.setLocationRelativeTo(this);
      	dlg.setVisible(true);
      	if (dlg.retourOK()) {
      		info.setText(listeVal.pointeurs.get(i).infoPourHistorique());
    		  cadre.listePr.metAJourObjetsDependantDe(val);      		
      		cadre.repaintFigureAvecCalcul();
      		listeVal.metAJourListe();
      		listeValSelectionChanged();
      		if (val.getNatureCalcul() == NatureCalcul.NVariable)
      			// frame.cadreActif().metAJourDialogueAffichageVariables((CVariableBornee) val);
      			frame.cadreActif().metAJourPaneAffichageVariables((CVariableBornee) val);
      		// Modification version 4.8 : On permet de modifier un calcul source du moment qu'il reste constant
      		// cadre.videListesPourConstructions();  // On remet  jour une construction ventuellement commence
      		if (cadre.listeObjetsSourcesNG.contains(val)) {
      			if (val.estDeNatureCalcul(NatureCalcul.NCalculReel | NatureCalcul.NCalculComplexe)) {
      				CCalcul calc = (CCalcul)val;
      				if (!calc.estConstant()) cadre.videListesPourConstructions(); 
      			}
      		}
      		else cadre.videListesPourConstructions();  // On remet  jour une construction ventuellement commence
      		// Fin modif
      		cadre.listePr.initialiseDependances(); // Ajout version 4.8
      	}
      }
  	}
  }

	public void mouseClicked(MouseEvent evt) {
    if (evt.getClickCount() == 2) {
    	int i = listeVal.getSelectedIndex();
    	if (i != -1) {
    		CElementBase elb = listeVal.pointeurs.get(i);
	  		if (elb.modifiableParMenu()) btnModifierActionPerformed();
    	}
    }
	}

	public void mouseEntered(MouseEvent arg0) {
		// TODO Auto-generated method stub
		
	}

	public void mouseExited(MouseEvent arg0) {
		// TODO Auto-generated method stub
		
	}

	public void mousePressed(MouseEvent arg0) {
		// TODO Auto-generated method stub
		
	}

	public void mouseReleased(MouseEvent arg0) {
		// TODO Auto-generated method stub
		
	}

}
