/*
MathGraph32 Java. Software for creating and animating dynamic mathematics figures
    Copyright (C) 2009  Yves Biton (France) http://mathgraph32.org 

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

package dialogs;

import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import javax.swing.Box;
import javax.swing.BoxLayout;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import mathgraph32.MtgFrame;
import objets.CListeObjets;
import objets.CRepere;

@SuppressWarnings("serial")
public class ChoixRepereEtNomCalcul extends MtgDlg {
	private ListeReperes listeReperes;
	private MtgLabel label1, label2;
	private EditeurNomCalcul editeurNom;
  private MtgButton btnOK;
  private MtgButton btnCancel;
  public CRepere repereChoisi;
  public String nomChoisi;
	
  public ChoixRepereEtNomCalcul(MtgFrame frameInit, String intitule, String intituleEditeur) {
    super(intitule, true, frameInit);
		editeurNom = new EditeurNomCalcul(frame);
    btnOK = new MtgButton(frame, getString("btnOK"));
    btnOK.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        btnOKActionPerformed();
      }
    });
    btnCancel = new MtgButton(frame, getString("btnCancel"));
    btnCancel.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        btnCancelActionPerformed();
      }
    });
    btnOK.setMaximumSize(btnCancel.getPreferredSize());
    label1 = new MtgLabel(frame, intituleEditeur, JLabel.RIGHT);
    label1.setRequestFocusEnabled(false);
    label2 = new MtgLabel(frame, getString("choixRepereDlg2"), JLabel.RIGHT);
    label2.setRequestFocusEnabled(false);
    CListeObjets liste = frame.cadreActif().listePr;
    listeReperes = new ListeReperes(frame, liste, liste.size() - 1);
    JScrollPane scrollPane= new JScrollPane(listeReperes,  JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED, 
    		JScrollPane.HORIZONTAL_SCROLLBAR_AS_NEEDED); 
    JPanel panePrincipal = new JPanel();
    JPanel paneLeft = new JPanel();
    JPanel paneRight = new JPanel();
    panePrincipal.setLayout(new BorderLayout());
    paneLeft.setLayout(new GridBagLayout());
    paneRight.setLayout(new BoxLayout(paneRight, BoxLayout.Y_AXIS));
    GridBagConstraints constraints = new GridBagConstraints();
    constraints.insets.bottom = 5;
    constraints.insets.top = 5;
    constraints.insets.left = 5;
    constraints.insets.right = 5;
    
    setConstraints(constraints, 0, 0, 1, 1, 60, 30, GridBagConstraints.NONE, GridBagConstraints.WEST);
    paneLeft.add(label1, constraints);
    setConstraints(constraints, 1, 0, 1, 1, 40, 30, GridBagConstraints.NONE, GridBagConstraints.WEST);
    paneLeft.add(editeurNom, constraints);
    setConstraints(constraints, 0, 1, 1, 1, 60, 70, GridBagConstraints.NONE, GridBagConstraints.WEST);
    paneLeft.add(label2, constraints);
    setConstraints(constraints, 1, 1, 1, 1, 40, 70, GridBagConstraints.NONE, GridBagConstraints.WEST);
    paneLeft.add(scrollPane, constraints);

    paneRight.add(Box.createRigidArea(new Dimension(0,5)));
    paneRight.add(btnOK);
    paneRight.add(Box.createRigidArea(new Dimension(0,5)));
    paneRight.add(btnCancel);
    panePrincipal.add(paneLeft,"West");
    panePrincipal.add(paneRight, "East");
    setContentPane(panePrincipal);
    getRootPane().setDefaultButton(btnOK);
    pack();    
  }
  
  private void btnCancelActionPerformed() {
  	repereChoisi = null;
    dispose();
  }       

  private void btnOKActionPerformed() {
  	CListeObjets listePr = frame.cadreActif().listePr;
    nomChoisi = editeurNom.getText();
    // On vrifie d'abord la validit du nom de la fonction
    // Modifi version 5.0
    if (!listePr.validationNomCalcul(frame, nomChoisi)) {
      editeurNom.requestFocus();
      return;    	
    }
  	int ind = listeReperes.getSelectedIndex();
  	if (ind == -1) repereChoisi = null;
  	else repereChoisi = listeReperes.repereChoisi();
  	dispose();
  	setRetourOK(true);
  }
}
