package dialogs;

import glob.Kernel;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Toolkit;
import java.awt.datatransfer.StringSelection;
import java.awt.event.ActionEvent;
import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;
import javax.swing.BoxLayout;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import objets.CCalculBase;
import objets.CListeObjets;
import types.ErreurCalculException;
import types.Int;

import mathgraph32.MtgFrame;
import mathgraph32.MtgInternalFrame;

/*
MathGraph32 Java. Software for creating and animating dynamic mathematics figures
    Copyright (C) 2009  Yves Biton (France) http://mathgraph32.org 

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

@SuppressWarnings("serial")
public class ExporterCodeTikzDlg extends MtgDlg {
	private MtgTextArea editeurCode;
	private JScrollPane scrollPaneCode;
	private MtgButton btnFermer,btnGenererCode,btnCopierCodeComplet,btnCopierCodeFigure;
	private MtgCheckBox checkUtiliserLongueurUnite, checkCodeCommente;
	public MtgTextField editeurCoefMult;
	private MtgLabel label1, infoTaille, infoLongueurUnite;
	public double coefMult = 1;
	private boolean coefOK = true;
	private double widthcm;
	private double heightcm;
	private boolean imagesExportees = false; // Sera mis  true si on a dj enregistr les images de la figure dans un fichier
	
  public ExporterCodeTikzDlg(MtgFrame frameInit) {
    super (getString("ExportTikzDlg1"), true, frameInit);
    initComponents();
    // getRootPane().setDefaultButton(btnFermer);
    editeurCoefMult.requestFocus();
  }

  private void initComponents() {
  	CListeObjets liste = frame.cadreActif().listePr;
  	label1 = new MtgLabel(frame, getString("ExportTikzDlg4"));
  	editeurCoefMult = new MtgTextField(frame, 6);
  	editeurCoefMult.setText("1"); // 1 cm par dfaut pour la longeur unit
  	editeurCoefMult.addKeyListener(new KeyListener() {		
			public void keyTyped(KeyEvent arg0) {
			}
			public void keyReleased(KeyEvent arg0) {
				verifieCoef();
			}
			public void keyPressed(KeyEvent arg0) {
			}
		});
 		editeurCode = new MtgTextArea(frame);
 		editeurCode.setRows(18);
 		editeurCode.setColumns(55);
    scrollPaneCode = new JScrollPane
  		(editeurCode, JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED, JScrollPane.HORIZONTAL_SCROLLBAR_AS_NEEDED);
    btnFermer = new MtgButton(frame, getString("btnFermer"));
    btnFermer.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent evt) {
        btnFermerActionPerformed();
      }
    });    
    btnGenererCode = new MtgButton(frame, getString("ExportTikzDlg2"));
    btnGenererCode.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent evt) {
        btnGenererCodeActionPerformed();
      }
    });
    btnCopierCodeComplet = new MtgButton(frame, getString("ExportTikzDlg3"));
    btnCopierCodeComplet.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent evt) {
        btnCopierCodeActionPerformed();
      }
    });
    btnCopierCodeFigure = new MtgButton(frame, getString("ExportTikzDlg6"));
    btnCopierCodeFigure.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent evt) {
        btnCopierCodeFigureActionPerformed();
      }
    });
    if (liste.pointeurLongueurUnite != null) {
	    checkUtiliserLongueurUnite = new MtgCheckBox(frame, getString("ExportTikzDlg7"));
	    checkUtiliserLongueurUnite.addActionListener(new java.awt.event.ActionListener() {
	      public void actionPerformed(ActionEvent evt) {
	        checkUtiliserLongueurUniteActionPerformed();
	      }
	    });
	    checkUtiliserLongueurUnite.setSelected(false);
    }
    checkCodeCommente = new MtgCheckBox(frame, getString("ExportTikzDlg8"),false);
  	infoTaille = new MtgLabel(frame);
  	infoLongueurUnite = new MtgLabel(frame);
  	infoLongueurUnite.setVisible(false);
    
    JPanel pane = new JPanel();
    pane.setLayout(new GridBagLayout());
    JPanel paneBoutons = new JPanel();
    GridBagConstraints constraints = new GridBagConstraints();
    constraints.insets.top = 4;
    constraints.insets.bottom = 4;
    constraints.insets.left = 5;
    constraints.insets.right = 5;
    
    paneBoutons.add(btnGenererCode);
    paneBoutons.add(btnCopierCodeComplet);
    paneBoutons.add(btnCopierCodeFigure, constraints);
    setConstraints(constraints, 0, 0, 2, 1, 80, 0, GridBagConstraints.NONE, GridBagConstraints.WEST);
    pane.add(paneBoutons, constraints);
    setConstraints(constraints, 0, 1, 1, 1, 30, 0, GridBagConstraints.NONE, GridBagConstraints.WEST);
    pane.add(label1, constraints);
    setConstraints(constraints, 1, 1, 1, 1, 30, 0, GridBagConstraints.NONE, GridBagConstraints.WEST);
    pane.add(editeurCoefMult, constraints);
    int i = 2;
    if (liste.pointeurLongueurUnite != null) {
	    setConstraints(constraints, 0, i, 2, 1, 50, 10, GridBagConstraints.NONE, GridBagConstraints.WEST);
	    pane.add(checkUtiliserLongueurUnite, constraints);
	    setConstraints(constraints, 1, i, 2, 1, 50, 10, GridBagConstraints.NONE, GridBagConstraints.WEST);
	    pane.add(checkCodeCommente, constraints);
	    setConstraints(constraints, 0, i+1, 2, 1, 50, 10, GridBagConstraints.NONE, GridBagConstraints.WEST);
	    pane.add(infoLongueurUnite, constraints);
	    i+=2;
    }
    setConstraints(constraints, 0, i, 2, 1, 50, 80, GridBagConstraints.NONE, GridBagConstraints.WEST);
    pane.add(scrollPaneCode, constraints);
    setConstraints(constraints, 0, i+1, 2, 1, 50, 10, GridBagConstraints.NONE, GridBagConstraints.WEST);
    pane.add(infoTaille, constraints);
    JPanel paneRight = new JPanel();
    paneRight.setLayout(new BoxLayout(paneRight, BoxLayout.Y_AXIS));
    paneRight.add(btnFermer);
    setConstraints(constraints, 2, 0, 1, 2, 0, 0, GridBagConstraints.NONE, GridBagConstraints.NORTHEAST);
    pane.add(paneRight, constraints);
    setContentPane(pane);
    displayInfoTaille();
    // if (liste.pointeurLongueurUnite != null) displayInfoUnite();
    pack();

  }
  
  private void btnFermerActionPerformed() {
  	setRetourOK(true);
  	dispose();
  }

  private void btnGenererCodeActionPerformed() {
  	if (!coefOK) {
  		dialogueAvertissement(getString("ch71"));
  		editeurCoefMult.requestFocus();
  	}
  	else {
  		if (!imagesExportees) {
  			frame.cadreActif().document.exporteImages();
  			imagesExportees = true;
  		}
  		boolean bu = ((frame.cadreActif().listePr.pointeurLongueurUnite != null) && checkUtiliserLongueurUnite.isSelected()) ? true : false;
  		// editeurCode.setText(frame.cadreActif().getTikz(coefMult, bu));
  		// Modification version 5.1.3 : Troisime paramtre qui est true si on veut que le code LaTeX soit comment
  		editeurCode.setText(frame.cadreActif().getTikz(coefMult, bu,checkCodeCommente.isSelected()));
  	}
  }
  
  private void btnCopierCodeActionPerformed() {
  	String ch = editeurCode.getText();
  	if (editeurCode.getText().isEmpty()) {
    	if (!coefOK) {
    		dialogueAvertissement(getString("ch71"));
    		return;
    	}
    	else {
    		boolean bu = ((frame.cadreActif().listePr.pointeurLongueurUnite != null) && checkUtiliserLongueurUnite.isSelected()) ? true : false;
    		Toolkit.getDefaultToolkit().getSystemClipboard().
    			setContents(new StringSelection(frame.cadreActif().getTikz(coefMult, bu,checkCodeCommente.isSelected())), null);
    		if (!imagesExportees) {
    			frame.cadreActif().document.exporteImages();
    			imagesExportees = true;
    		}
    	}
    	return;
  		
  	}
  	ch = editeurCode.getSelectedText();
  	if (ch == null) ch = editeurCode.getText();
  	Toolkit.getDefaultToolkit().getSystemClipboard().setContents(new StringSelection(ch), null);
  }

  private void btnCopierCodeFigureActionPerformed() {
  	if (!coefOK) {
  		dialogueAvertissement(getString("ch71"));
  		return;
  	}
		boolean bu = ((frame.cadreActif().listePr.pointeurLongueurUnite != null) && checkUtiliserLongueurUnite.isSelected()) ? true : false;
  	String  ch = frame.cadreActif().getTikzCodeOnly(coefMult, bu,checkCodeCommente.isSelected());
		if (!imagesExportees) {
			frame.cadreActif().document.exporteImages();
			imagesExportees = true;
		}
  	Toolkit.getDefaultToolkit().getSystemClipboard().setContents(new StringSelection(ch), null);
  }
  
  private void checkUtiliserLongueurUniteActionPerformed() {
  	editeurCode.setText("");
  	displayInfoUnite();
  	infoLongueurUnite.setVisible(checkUtiliserLongueurUnite.isSelected());
  	displayInfoTaille();
  	displayInfoUnite();
  	pack();
  }
  
  private void verifieCoef() {
  	MtgInternalFrame cadre = frame.cadreActif();
  	editeurCode.setText("");
  	infoLongueurUnite.setText("");
    CListeObjets liste = cadre.listePr;
    String rep = editeurCoefMult.getText();
    Int inderr = new Int();    
  	if (CCalculBase.verifieSyntaxe(liste, rep, inderr, 0, null)) {
      CCalculBase calc = CCalculBase.creeCalculBase(rep ,liste, 0, rep.length()-1, null);
      try {
        calc.listeProprietaire.initialiseNombreIterations();
        coefMult = calc.resultat(false);
      }
      catch (ErreurCalculException e) {
      	infoTaille.setText("");
      	coefOK = false;
        return;
      }
      coefOK = (coefMult >=0.1) & (coefMult<=10);
      displayInfoTaille();
      if (liste.pointeurLongueurUnite != null) displayInfoUnite();
      return;
  	}
  	else {
  		coefOK = false;
  		infoTaille.setText("");
  		return;
  	}
  }

  private void displayInfoTaille() {
  	double unite;
  	MtgInternalFrame cadre = frame.cadreActif();
  	CListeObjets liste = cadre.listePr;
  	if ((liste.pointeurLongueurUnite != null) && checkUtiliserLongueurUnite.isSelected()) unite = cadre.listePr.pointeurLongueurUnite.rendLongueur();
  	else unite = (double) Toolkit.getDefaultToolkit().getScreenResolution() / 2.54;
		widthcm = coefMult*cadre.dimf.longueurAbscisses / unite;
		heightcm = coefMult*cadre.dimf.longueurOrdonnees / unite;
		infoTaille.setText(glob.Kernel.chaineNombre(widthcm, 2) + " cm x " + glob.Kernel.chaineNombre(heightcm, 2) + " cm");
  }
  
  private void displayInfoUnite() {
  	String ch = getString("ExportTikzDlg5") + " " + Kernel.chaineNombre(coefMult, 4) + " cm";
  	infoLongueurUnite.setText(ch);
  }
}