/*
MathGraph32 Java. Software for creating and animating dynamic mathematics figures
    Copyright (C) 2009  Yves Biton (France) http://mathgraph32.org 

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

package dialogs;

import java.util.ListIterator;
import java.util.Vector;
import javax.swing.DefaultListModel;
import javax.swing.JList;
import javax.swing.ListSelectionModel;
import mathgraph32.MtgFrame;
import objets.CBarycentre;
import objets.CNoeudPondere;
import types.FonteNom;

@SuppressWarnings("serial")
public class ListeModifBarycentre extends JList<String>{
	private CBarycentre barycentre;
  private DefaultListModel<String> listModel;
  public ListeModifBarycentre(MtgFrame frame, CBarycentre barycentreInit) {
    super();
		setFont(FonteNom.getFonteEdition(MtgFrame.sizeFontList, FonteNom.Normal,
				(double)frame.pref_addSystemFont/MtgFrame.sizeFontList + MtgFrame.coefMultForSystemFonts));		
    barycentre = barycentreInit;
    listModel = new DefaultListModel<String>();
    setModel(listModel);
    setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
    metAJour();
  }
  
  public final void metAJour() {
    Vector<String> values = new Vector<String> ();
    ListIterator<CNoeudPondere> li = barycentre.col.listIterator();
    while(li.hasNext()) {
      CNoeudPondere noeud = li.next();
      values.add(MtgFrame.getString("ModificationBarycentreDlg2") + " : " + noeud.pointAssocie.nom() +" : " + noeud.poids.chaineInfo() + " ");
      setListData(values);
      setVisibleRowCount(6);
      setSelectedIndex(0);
    }  	
  }
}
