/*
MathGraph32 Java. Software for creating and animating dynamic mathematics figures
    Copyright (C) 2009  Yves Biton (France) http://mathgraph32.org 

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
package dialogs;

import java.io.File;
import java.net.URL;
import javax.swing.Icon;
import javax.swing.ImageIcon;
import javax.swing.filechooser.FileView;
import mathgraph32.Global;
import mathgraph32.MtgFrame;

public class MtgFileView extends FileView {
	Icon iconDoc;
	Icon iconMacro;
	Icon iconOldDoc;
	
	public MtgFileView() {
    URL adr = MtgFrame.class.getResource("images/IconeDoc.png");
    iconDoc = new ImageIcon(adr);
    adr = MtgFrame.class.getResource("images/IconeMacro.png");
    iconMacro =  new ImageIcon(adr);
    adr = MtgFrame.class.getResource("images/IconeOldDoc.gif");
    iconOldDoc =  new ImageIcon(adr); 
	}
  public Icon getIcon(File file) {
    if (file.isDirectory()) {
      return null;
    }
    Icon icon = null;
    String filename = file.getName().toLowerCase();
    if (filename.endsWith(Global.GLOBAL_COMMA_MGJ)) 
      icon = iconDoc;
    else 
      if (filename.endsWith(Global.GLOBAL_COMMA_MGF))
        icon = iconOldDoc;
    	
    	 if (filename.endsWith(Global.GLOBAL_COMMA_MGC))
    		 icon = iconMacro;
    	
    return icon;
  }

}
