/*
MathGraph32 Java. Software for creating and animating dynamic mathematics figures
    Copyright (C) 2009  Yves Biton (France) http://mathgraph32.org 

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

package dialogs;

import java.awt.event.FocusEvent;
import java.awt.event.FocusListener;
import javax.swing.JDialog;
import javax.swing.JTextField;

import mathgraph32.MtgFrame;
import types.FonteNom;

@SuppressWarnings("serial")
public class TextFieldAvecCarSpeciaux extends JTextField implements FocusListener {
	private MtgFrame frame;
	private JDialog owner; // La bote de dialogue qui contient le champ
	private int natureCarPermis; // CF NatureCarSpe donne quels sont les sets de caractres autoriss pour ce champ
	CaracteresSpeciauxDlg caracteresSpeciauxDlg;
	
	public TextFieldAvecCarSpeciaux(JDialog ownerInit, MtgFrame frameInit, int natureCarPermisInit) {
		owner = ownerInit;
		frame = frameInit;
		natureCarPermis = natureCarPermisInit;
		addFocusListener(this);
		caracteresSpeciauxDlg = null;
		setFont(FonteNom.getFonteEdition(MtgFrame.sizeFontList, FonteNom.Normal,
				(double)frame.pref_addSystemFont/MtgFrame.sizeFontList + MtgFrame.coefMultForDlgBoxIcons));				
	}

	public void focusGained(FocusEvent e) {
		if (caracteresSpeciauxDlg == null) caracteresSpeciauxDlg = 

			new CaracteresSpeciauxDlg(owner, MtgFrame.getString("ch84"), frame, natureCarPermis);		
		if (!caracteresSpeciauxDlg.isVisible()) {
			caracteresSpeciauxDlg.positionneParRapportDialoguePere();
			caracteresSpeciauxDlg.AssocieA(this);
			caracteresSpeciauxDlg.setVisible(true);
		}
		requestFocus();
	}

	public void focusLost(FocusEvent e) {
		if (!e.isTemporary()) { 
			caracteresSpeciauxDlg.setVisible(false);
			caracteresSpeciauxDlg = null;
		}
	}

}
