/*
MathGraph32 Java. Software for creating and animating dynamic mathematics figures
    Copyright (C) 2009  Yves Biton (France) http://mathgraph32.org 

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
package mathgraph32;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import javax.swing.JButton;

@SuppressWarnings("serial")
public class MtgButtonFinAction extends JButton implements ActionListener {
	MtgFrame frame;
	public MtgButtonFinAction(MtgFrame frameInit) {
		super(new MtgImageIcon(MtgFrame.screenIsHighResolution ? 1.5 : 0.5, MtgFrame.class.getResource("images/SourisClicDroit.png")));
		setToolTipText(MtgFrame.getString("clicDt"));
		frame = frameInit;
		addActionListener(this);
	}
	public void actionPerformed(ActionEvent e) {
		 MtgInternalFrame cadre = frame.cadreActif();
		 if (cadre != null) frame.outilActif.creeObjetApresClicDroit();
	}
}