/*
MathGraph32 Java. Software for creating and animating dynamic mathematics figures
    Copyright (C) 2009  Yves Biton (France) http://mathgraph32.org 

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

package mathgraph32;

import javax.swing.BoxLayout;
import javax.swing.JPopupMenu;
import actions.MtgAction;
import objets.CMathGrafDoc;

/**
 * Version 5.0 : Classe reprsentant un menu hoizontal apparaissant quand on clique sur une flche
 * situe  droite d'une icne reprsentant une famille d'actions possibles.
 * @author Yves
 */
@SuppressWarnings("serial")
public class MtgHorizontalMenu extends JPopupMenu {
	private MtgFrame frame;
	private MtgAction[] tabact; // Un tableau contenant les actions dont les icnes doivent tre dans le menu
	private MtgIconButton mtgIconButton; // L'icne dont le clic sur la flche droule le menu
	public MtgHorizontalMenu(MtgFrame frameInit, MtgAction[] tabactInit, MtgIconButton mtgIconButtonInit) {
		super();
		frame = frameInit;
		tabact = tabactInit;
		mtgIconButton = mtgIconButtonInit;
		setLayout(new BoxLayout(this, BoxLayout.LINE_AXIS));
		MtgInternalFrame cadre = frame.cadreActif();
		CMathGrafDoc doc = cadre != null ? cadre.document : null;
		for (int i = 0; i < tabact.length; i++) {
			MtgAction action = tabact[i];
			if ((doc  == null) || (doc.itemPermis(action.idMenu()) && frame.docPreferencesNiveau[frame.pref_niveau].itemPermis(action.idMenu()) &&
					((action.outilAssocie == null) || action.outilAssocie.activationValide()))) {
				MtgIconItem item = new MtgIconItem(action, mtgIconButton);
				add(item);
			}
		}
	};
}
