/*
MathGraph32 Java. Software for creating and animating dynamic mathematics figures
    Copyright (C) 2009  Yves Biton (France) http://mathgraph32.org 

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
package mathgraph32;
import java.awt.Color;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import javax.swing.JPanel;
import javax.swing.JToolBar;
import dialogs.MtgDlg;

@SuppressWarnings("serial")
public class MtgPaneChoixCouleur extends JPanel implements MouseListener  {
	private MtgFrame frame;
	private static Insets ins = new Insets(0, 0, 0, 0);
	
  public MtgPaneChoixCouleur(MtgFrame frameInit) {
    super();
    frame = frameInit;
  	// 16 boutons de choix de couleur prdfinie
		MtgOneColorButton oneColorButton1 = new MtgOneColorButton(frame, new Color(0, 0, 0));
		MtgOneColorButton oneColorButton2 = new MtgOneColorButton(frame, new Color(0, 0, 255));
		MtgOneColorButton oneColorButton3 = new MtgOneColorButton(frame, new Color(0, 255, 0));
		MtgOneColorButton oneColorButton4 = new MtgOneColorButton(frame, new Color(255, 0, 0));
		MtgOneColorButton oneColorButton5 = new MtgOneColorButton(frame, new Color(0, 255, 255));
		MtgOneColorButton oneColorButton6 = new MtgOneColorButton(frame, new Color(255, 0, 255));
		MtgOneColorButton oneColorButton7 = new MtgOneColorButton(frame, new Color(255, 255, 0));
		MtgOneColorButton oneColorButton8 = new MtgOneColorButton(frame, new Color(127, 127, 127));
		MtgOneColorButton oneColorButton9 = new MtgOneColorButton(frame, new Color(0, 0, 127));
		MtgOneColorButton oneColorButton10 = new MtgOneColorButton(frame, new Color(0, 127, 0));
		MtgOneColorButton oneColorButton11 = new MtgOneColorButton(frame, new Color(127, 0, 0));
		MtgOneColorButton oneColorButton12 = new MtgOneColorButton(frame, new Color(0, 127, 127));
		MtgOneColorButton oneColorButton13 = new MtgOneColorButton(frame, new Color(127, 0, 127));
		MtgOneColorButton oneColorButton14 = new MtgOneColorButton(frame, new Color(127, 127, 0));
		MtgOneColorButton oneColorButton15 = new MtgOneColorButton(frame, new Color(102, 102, 102));
		MtgOneColorButton oneColorButton16 = new MtgOneColorButton(frame, new Color(51, 51, 51));    
		// Les 4 barres d'outils verticales servant  contenr les 14 boutons
		// de couleurs prdfinies.
		JToolBar barCouleur1 = new JToolBar(JToolBar.VERTICAL);
		JToolBar barCouleur2 = new JToolBar(JToolBar.VERTICAL);
		JToolBar barCouleur3 = new JToolBar(JToolBar.VERTICAL);
		JToolBar barCouleur4 = new JToolBar(JToolBar.VERTICAL);
		barCouleur1.setMargin(ins);
		barCouleur2.setMargin(ins);
		barCouleur3.setMargin(ins);
		barCouleur4.setMargin(ins);
		barCouleur1.setFloatable(false);
		barCouleur2.setFloatable(false);
		barCouleur3.setFloatable(false);
		barCouleur4.setFloatable(false);
		barCouleur1.add(oneColorButton1);
		barCouleur1.add(oneColorButton5);
		barCouleur1.add(oneColorButton9);
		barCouleur1.add(oneColorButton13);
		barCouleur2.add(oneColorButton2);
		barCouleur2.add(oneColorButton6);
		barCouleur2.add(oneColorButton10);
		barCouleur2.add(oneColorButton14);
		barCouleur3.add(oneColorButton3);
		barCouleur3.add(oneColorButton7);
		barCouleur3.add(oneColorButton11);
		barCouleur3.add(oneColorButton15);
		barCouleur4.add(oneColorButton4);
		barCouleur4.add(oneColorButton8);
		barCouleur4.add(oneColorButton12);
		barCouleur4.add(oneColorButton16);
		GridBagConstraints constraints = new GridBagConstraints();
		constraints.insets.bottom = 0;
		constraints.insets.top = 0;
		constraints.insets.left = 0;
		constraints.insets.right = 0;		
		setLayout(new GridBagLayout());
		MtgDlg.setConstraints(constraints, 0, 0, 1, 1, 50, 100,
				GridBagConstraints.NONE, GridBagConstraints.EAST);
		add(barCouleur1, constraints);
		MtgDlg.setConstraints(constraints, 1, 0, 1, 1, 50, 0,
				GridBagConstraints.NONE, GridBagConstraints.CENTER);
		add(barCouleur2, constraints);
		MtgDlg.setConstraints(constraints, 2, 0, 1, 1, 50, 0,
				GridBagConstraints.NONE, GridBagConstraints.WEST);
		add(barCouleur3, constraints);
		MtgDlg.setConstraints(constraints, 3, 0, 1, 1, 50, 0,
				GridBagConstraints.NONE, GridBagConstraints.WEST);
		add(barCouleur4, constraints);
	}
	
	public void mouseClicked(MouseEvent arg0) {
	}  
	public void mouseEntered(MouseEvent arg0) {
    if (getCursor() != MtgFrame.defaultCursor) frame.setCursor(MtgFrame.defaultCursor);
	}
	public void mouseExited(MouseEvent arg0) {
	}
	public void mousePressed(MouseEvent arg0) {
	}
	public void mouseReleased(MouseEvent arg0) {
	}  
  
	
}
