/*
MathGraph32 Java. Software for creating and animating dynamic mathematics figures
    Copyright (C) 2009  Yves Biton (France) http://mathgraph32.org 

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

package objets;

import java.awt.Color;
import java.awt.Graphics2D;
import java.io.IOException;

import types.DimensionFenetre;

import entreesSorties.MathGraphDataInputStream;
import entreesSorties.MathGraphDataOutputStream;


public class CSurfaceRemplie extends CSurfaceAncetre {
	CPointAncetre pointInterieur;
	CSousListeObjets listeBord;

  /** Creates new CSurfaceRemplie */
  public CSurfaceRemplie() {
    listeBord = new CSousListeObjets();
  }
  
  // Constructeur pour clonage
   public CSurfaceRemplie(CListeObjets liste, CImplementationProto impProtoInit, boolean estElementFinalInit,
        Color couleurInit, boolean masqueInit, int styleRemplissageInit,
        CPointAncetre pointInterieurInit, CSousListeObjets listeBordInit) {
     super(liste, impProtoInit, estElementFinalInit, couleurInit, masqueInit, styleRemplissageInit);
     pointInterieur = pointInterieurInit;
     listeBord = listeBordInit;     
   }  
  
  public CElementBase getClone(CListeObjets listeSource, CListeObjets listeCible) {
    int ind1 = listeSource.indexOf(pointInterieur);
    int ind2 = listeSource.indexOf(impProto);        
    listeBord = new CSousListeObjets();
    CElementBase ptelb = new CSurfaceRemplie(listeCible, (CImplementationProto)(listeCible.get(ind2, CImplementationProto.class)),
      estElementFinal, couleur, masque, styleRemplissage, (CPointAncetre)(listeCible.get(ind1, CPointAncetre.class)), listeBord);
    listeBord.setImage(((CSurfaceRemplie)ptelb).listeBord, listeProprietaire, ptelb.listeProprietaire);
    return ptelb;
  }
  
  @Override
  public void positionne(boolean infoRandom, DimensionFenetre dimfen) {
    existe = false; // classe non implmente en java
  }
  
  @Override
  public void trace(Graphics2D pDC, Color couleurFond, float transparence) {
  }
  
  @Override
	public boolean estDefiniParObjetDans(CListeObjets listeOb) {
  	return false; // Objet plus utilis
	}         

  @Override
  public void chargeDepuisFlux(MathGraphDataInputStream inps, CListeObjets list) throws IOException {
    super.chargeDepuisFlux(inps, list);
    int ind1 = inps.readCInt();
    pointInterieur = (CPointAncetre) (list.get(ind1,CPointAncetre.class));
    listeBord.chargeDepuisFlux(inps, listeProprietaire);
  }
  
  @Override
  public void read(MathGraphDataInputStream inps, CListeObjets list)  throws IOException {
    super.read(inps, list);
    int ind1 = inps.readInt();
    pointInterieur = (CPointAncetre) (list.get(ind1,CPointAncetre.class));
    listeBord.read(inps, listeProprietaire);
  }
  
  @Override
  public void write(MathGraphDataOutputStream oups, CListeObjets list)  throws IOException {
    super.write(oups, list);
    int ind1 = list.indexOf(pointInterieur);
    oups.writeInt(ind1);
    listeBord.write(oups, list);
  }    
}
