/*
MathGraph32 Java. Software for creating and animating dynamic mathematics figures
    Copyright (C) 2009  Yves Biton (France) http://mathgraph32.org 

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

package outils;

import objets.CArcDeCercleIndirect;
import objets.CListeObjets;
import objets.CValeurAngle;
import dialogs.AngleArcDlg;
import mathgraph32.MtgFrame;

public class OutilArcIndirectParAngle extends OutilPar2pts {
  public OutilArcIndirectParAngle(MtgFrame frameInit) {
    super(frameInit);
  }
	/**
	 * Ajout versions 5.0.
	 * Renverra true si on peut cre un point quand on clique sur un endroit vide de la figure.
	 * Devra tre redfini pour les outils pour lesquels ce n'est pas possible comme les outils de mesure.
	 * @return
	 */
	protected boolean creationPointPossible() {
		return true;
	}

  @Override
  public void creeObjet() {
    CListeObjets liste = frame.cadreActif().listePr;
    CValeurAngle ang = new CValeurAngle(liste, 0, "0");
    CArcDeCercleIndirect ptArc = new CArcDeCercleIndirect(frame.cadreActif().listePr, null, false, 
       frame.couleurActive(), false, frame.styleTraitActif(), point1, point2, null, ang);
    // On cre un dialogue modal permettant d'entrer l'angle de la rotation
    AngleArcDlg angleArcDlg = new AngleArcDlg(frame, ptArc, false);
		angleArcDlg.setLocationRelativeTo(frame);
    angleArcDlg.setVisible(true);    
    if (angleArcDlg.retourOK()) {    
	    if (frame.ajouteElementAvecVerification(ptArc))
	      frame.cadreActif().gestionnaire.enregistreFigureEnCours(getString("chaineOutil31"));
	    annuleClignotement();
    }
    // Provisoire
    select();
  }
  
  @Override
  public String chaineIndication (int indEtape) {
    switch (indEtape) {
      case 1 : return getString("arcPetitParPointFinal1");
      case 2 : return getString("arcPetitParPointFinal2");
      case 3 : return getString("arcPetitParAngle3");
      default: return "";
    }
  }	

}
