/*
MathGraph32 Java. Software for creating and animating dynamic mathematics figures
    Copyright (C) 2009  Yves Biton (France) http://mathgraph32.org 

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

package outils;

import java.awt.Point;

import mathgraph32.MtgFrame;
import objets.CCentreCercle;
import objets.CCercle;
import objets.CElementGraphique;
import types.NatureObjet;

public class OutilCentreCercle extends Outil {
	CCercle cercle1;
	
	public OutilCentreCercle(MtgFrame frameInit) {
		super(frameInit, false);
	}

  @Override
	public void select() {
		super.select();
		cercle1 = null;
		frame.outilPointageActif = frame.outilPointageCre;
		frame.outilPointageActif.designationDe(NatureObjet.NCercle);
		frame.indication(getString("centreCercle1"));
    frame.outilPointageObjetClignotant.reset();
	}
	
	public void traiteObjetDesigne(CElementGraphique elg, Point pointClique) {
    if (cercle1 == null) {
      cercle1 = (CCercle) elg;
      creeObjet();
    }
	}
	
  @Override       
  public void creeObjet() {
    CCentreCercle pt = new CCentreCercle(frame.cadreActif().listePr, null, false, frame.couleurActive(),
      false, 0, 3, false, "", frame.pref_indiceTaillePoliceNom, frame.stylePointActif, cercle1, false);
    if (frame.ajouteElementAvecVerification(pt))
      frame.cadreActif().gestionnaire.enregistreFigureEnCours(getString("chaineOutil114"));
    annuleClignotement();
    select();
  }
	
  @Override
	public boolean activationValide() {
		return frame.cadreActif().listePr.nombreObjetsParNature(NatureObjet.NCercle) != 0;
	}
	
	@Override
	public String messageActivationNonValide() {
		return getString("messagePasDeCercle") + "\n";
	}	  
}
