/*
MathGraph32 Java. Software for creating and animating dynamic mathematics figures
    Copyright (C) 2009  Yves Biton (France) http://mathgraph32.org 

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
package outils;

import java.awt.Point;

import mathgraph32.MtgFrame;
import mathgraph32.MtgInternalFrame;
import objets.CElementGraphique;
import objets.CListeObjets;
import objets.CPointAncetre;
import types.NatureObjet;

public class OutilDemarquerPointPourTrace extends Outil {
	private int nbPointsDesignes;
	private boolean sauveModeTrace;
	public OutilDemarquerPointPourTrace(MtgFrame frameInit) {
		super(frameInit, true);
	}

  @Override
	public void select() {
		super.select();
		nbPointsDesignes = 0;
		MtgInternalFrame cadre = frame.cadreActif();
		sauveModeTrace = cadre.document.modeTraceActive;
		cadre.activeModeTrace(false);
		CListeObjets liste = frame.cadreActif().listePr;
		frame.listeClignotante.ajoutePointsMarquesPourTrace(liste, true);// Ajoute les points qui sont marqus pour la trace	
		frame.outilPointageActif = frame.outilPointageObjetClignotant;
		frame.outilPointageActif.designationDe(NatureObjet.NToutPoint);
		frame.indication(getString("demarquagePointPourTrace"));
		resetClignotement();		
	}
  
	public void traiteObjetDesigne(CElementGraphique elg, Point pointClique) {
		nbPointsDesignes++;
		frame.listeClignotante.remove(elg);
    ((CPointAncetre) elg).marquePourTrace = false;
    if (frame.listeClignotante.size() == 0) frame.activeOutilCapture();
    else resetClignotement();
  }
	
	@Override
	public void creeObjetApresClicDroit() {
   MtgInternalFrame cadre = frame.cadreActif();
   if (nbPointsDesignes != 0) {
    	cadre.gestionnaire.enregistreFigureEnCours(getString("chaineOutil150"));
    }
    cadre.activeModeTrace(sauveModeTrace);
    frame.activeOutilCapture();
	}

}
