/*
MathGraph32 Java. Software for creating and animating dynamic mathematics figures
    Copyright (C) 2009  Yves Biton (France) http://mathgraph32.org 

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

package outils;

import objets.CDroiteOm;
import objets.CListeObjets;
import objets.CValeurAssocieeAVariable;
import types.NatureCalcul;
import dialogs.CoefficientDirecteurDlg;
import mathgraph32.MtgFrame;

public class OutilDroiteParCoef extends OutilParPoint {

	/** Constructeur */
	public OutilDroiteParCoef(MtgFrame frameInit) {
		super(frameInit);
	}

  @Override
  public void creeObjet() {
  	CListeObjets liste = frame.cadreActif().listePr;
  	
    CDroiteOm dte = new CDroiteOm(liste, frame.couleurActive(),frame.styleTraitActif(), null,
    		point, new CValeurAssocieeAVariable(liste, 0d), frame.pref_indiceTaillePoliceNom);
    // dialogue de choix des caractristiques du repre
    CoefficientDirecteurDlg dlg = new CoefficientDirecteurDlg(frame, dte, false);
		dlg.setLocationRelativeTo(frame);
    dlg.setVisible(true);
    if (dlg.retourOK()) {
      if (frame.ajouteElementAvecVerification(dte)) {
        frame.cadreActif().gestionnaire.enregistreFigureEnCours(getString("chaineOutil43"));
        frame.cadreActif().repaintFigureAvecCalcul();
      }
    }
    select();
  }
  
  @Override
  public String chaineIndication(int indEtape) {
    switch(indEtape) {
      case 1 : return getString("droiteParCoef1");
      default: return "";
    }
  }
  
  @Override
	public boolean activationValide() {
		CListeObjets liste = frame.cadreActif().listePr;
		return (liste.nombreObjetsParNatureCalculNonIntermediaires(NatureCalcul.NRepere)!=0);
	}
	
	@Override
	public String messageActivationNonValide() {
		CListeObjets liste = frame.cadreActif().listePr;
		if (liste.nombreObjetsParNatureCalculNonIntermediaires(NatureCalcul.NRepere)==0) return getString("messagePasDeRepere");
		else return "";
	}	  
  
}
