/*
MathGraph32 Java. Software for creating and animating dynamic mathematics figures
    Copyright (C) 2009  Yves Biton (France) http://mathgraph32.org 

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
package outils;

import mathgraph32.MtgFrame;
import objets.CGrapheSuiteRecComplexe;
import objets.CListeObjets;
import types.NatureCalcul;
import dialogs.GrapheSuiteRecurrenteComplexeDlg;

public class OutilGrapheSuiteRecurrenteComplexe extends Outil {
  public OutilGrapheSuiteRecurrenteComplexe(MtgFrame frameInit) {
    super(frameInit, false);
  }
  
  @Override
	public boolean activationValide() {
  	// Modifi version 4.7.5
		return (frame.cadreActif().listePr.nombreObjetsParNatureCalculNonIntermediaires(NatureCalcul.NRepere)!=0)
						&& (frame.cadreActif().listePr.nombreObjetsParNatureCalculNonIntermediaires
								(NatureCalcul.NSuiteRecurrenteComplexe | NatureCalcul.NSuiteRecurrenteComplexe2 | NatureCalcul.NSuiteRecurrenteComplexe3)!=0);
	}
	
	@Override
	public String messageActivationNonValide() {
		String ch = "";
		if (frame.cadreActif().listePr.nombreObjetsParNatureCalculNonIntermediaires(NatureCalcul.NRepere)==0) ch = ch + getString("messagePasDeRepere") + "\n";
		if (frame.cadreActif().listePr.nombreObjetsParNatureCalculNonIntermediaires
				(NatureCalcul.NSuiteRecurrenteComplexe | NatureCalcul.NSuiteRecurrenteComplexe2 | NatureCalcul.NSuiteRecurrenteComplexe3)==0)
			ch = ch + getString("messagePasDeSuiteComplexe");
		return ch;
	}	
  
  @Override
  public void select() {
    super.select();
    frame.indication(getString("grapheSuite1"));
    CListeObjets liste = frame.cadreActif().listePr;
    CGrapheSuiteRecComplexe graphe = new CGrapheSuiteRecComplexe(liste, null, false, frame.couleurActive(),
    		false, frame.styleTraitActif(), null, null, frame.stylePointActif, true);
    GrapheSuiteRecurrenteComplexeDlg dlg = new GrapheSuiteRecurrenteComplexeDlg(frame, graphe, false);
		dlg.setLocationRelativeTo(frame);
    dlg.setVisible(true);
    if (dlg.retourOK()) {
      if (frame.ajouteElementAvecVerification(graphe)) {
        frame.cadreActif().gestionnaire.enregistreFigureEnCours(getString("chaineOutil77"));
        frame.cadreActif().repaintFigureAvecCalcul();
      }
    }
    frame.activeOutilCapture();
  } 
}
