/*
MathGraph32 Java. Software for creating and animating dynamic mathematics figures
    Copyright (C) 2009  Yves Biton (France) http://mathgraph32.org 

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

package outils;

import java.awt.Color;

import objets.CListeObjets;
import objets.CMarqueAngleGeometrique;
import objets.CPointBase;
import objets.CPointProjete;
import objets.CSegment;
import types.StyleMarqueAngle;
import types.StyleTrait;

import mathgraph32.MtgFrame;

public class OutilProjeteOrthogonal extends OutilParDtPt {
  public OutilProjeteOrthogonal(MtgFrame frameInit) {
    super(frameInit);
  }
  
  
  @Override     
  public void creeObjet() {
   CPointProjete pt = new CPointProjete(frame.cadreActif().listePr, null,
       false, frame.couleurActive(), false, 0, 3, false, frame.genereNomPourPoint(), frame.pref_indiceTaillePoliceNom,
       frame.stylePointActif(), point1, droite1, false);
    if (frame.ajouteElementAvecVerification(pt))
      frame.cadreActif().gestionnaire.enregistreFigureEnCours(getString("chaineOutil39"));
    annuleClignotement();
    select();
  }
  /** Mthode ajoutant les objets visuels  la liste listeObjetsVisuels de l'applet
   * au fur et  mesure que l'on dsigne les obejts  la souris
   * Doit tre redfini pour chaque outil utilisant une aide visuelle  la cration
   */
  
  @Override     
  public void ajouteObjetsVisuels() {
  	CListeObjets liste = frame.cadreActif().listePr;
  	// On cre un point qui reprsente un point de l'objet sur lequel on veut projeter
  	CPointBase pt = new CPointBase(liste, null, false);
  	pt.placeEn(droite1.point_x, droite1.point_y);
  	pt.cache();
  	frame.listeObjetsVisuels.add(pt);

  	// On cre le projet orthogonal du point souris (n'existe pas forcment)
  	CPointProjete proj = new CPointProjete(liste, null, false, frame.couleurActive(), false, frame.stylePointActif(),
  			frame.cadreActif().paneFigure.pointSouris, droite1);
  	frame.listeObjetsVisuels.add(proj);
  	// On  cre une marque d'angle
  	CMarqueAngleGeometrique ptma = new CMarqueAngleGeometrique(liste, null, false, Color.black, false,
  			StyleTrait.traitFin, StyleMarqueAngle.marqueSimple, MtgFrame.screenIsHighResolution ? 24 : 12, pt, proj, frame.cadreActif().paneFigure.pointSouris);
  	frame.listeObjetsVisuels.add(ptma);
  	// On  cre un segment en pointills
  	CSegment seg = new CSegment(liste, null, false, Color.black, false, StyleTrait.traitPointille,
  			frame.cadreActif().paneFigure.pointSouris, proj);
  	frame.listeObjetsVisuels.add(seg);
  }
  
  @Override     
  public String chaineIndication (int indEtape) {
    switch(indEtape) {
      case 1 : return getString("projete1");
      case 2 : return getString("projete2");
      default: return "";
    }
  }	

}