/*
MathGraph32 Java. Software for creating and animating dynamic mathematics figures
    Copyright (C) 2009  Yves Biton (France) http://mathgraph32.org 

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
package outils;

import java.awt.Point;
import mathgraph32.MtgFrame;
import objets.CElementGraphique;
import objets.CListeObjets;
import objets.CPointAncetrePointsMobiles;
import types.NatureObjet;

public class OutilPunaiserPointMobile extends Outil {
	
	public OutilPunaiserPointMobile(MtgFrame frameInit) {
		super(frameInit, true);
	}

  @Override
	public void select() {
		super.select();
		CListeObjets liste = frame.cadreActif().listePr;
		frame.listeClignotante.ajoutePointsLibresVisibles(liste, true);
		frame.outilPointageActif = frame.outilPointageObjetClignotant;
		frame.outilPointageActif.designationDe(NatureObjet.NPointMobile);
		frame.indication(getString("punaiser1"));
		resetClignotement();		
	}	

  @Override
	public void traiteObjetDesigne(CElementGraphique elg, Point pointClique) {
		CPointAncetrePointsMobiles pointMobile = (CPointAncetrePointsMobiles) elg;
		pointMobile.pointLibre = false;
		frame.dialogueInformation(getString("ch124"));
		annuleClignotement();
	  frame.cadreActif().gestionnaire.enregistreFigureEnCours(getString("chaineOutil100"));
		select();
	}
	
}
